<?php
 
/* $Id;  */
 
/**
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
* 
* The authors can be contacted at: 
*  - arthur [at] civicactions (dot) com
*  - jonathan [at] civicactions (dot) com
* 
* @license http://www.affero.org/oagpl.html
* @link    http://civications.com
*/

define('MM_EMAIL_WATCHDOG_TYPE', 'media mover email');



/**
 * open questions:
 * 
 * log files?
 * settings - does media mover already have an admin
 * 
 * @param array $file
 * @param array $configuration
 * 
 * @return $files
 * 
 * 
 * */
function _media_mover_email_harvest(&$file_data_array, $action, $configuration) {
  
  $mailserver_uri = $configuration['mm_email_account_server'];
  $mailserver_port = $configuration['mm_email_account_port'];
  $mailserver_login = $configuration['mm_email_account_name'];
  $mailserver_password = $configuration['mm_email_account_password'];
  $mm_email_delete_emails = $configuration['mm_email_delete_emails'];
  
  $mm_email_confirm_send_emails = $configuration['mm_email_confirm_send_emails'];
  $mm_email_confirm_from = $configuration['mm_email_confirm_from'];
  $mm_email_confirm_reply_to = $configuration['mm_email_confirm_reply_to'];
  $mm_email_confirm_subject = $configuration['mm_email_confirm_subject'];
  $mm_email_confirm_text = $configuration['mm_email_confirm_text'];
  
  $mm_email_bounce_send_emails = $configuration['mm_email_bounce_send_emails'];
  $mm_email_bounce_reply_to = $configuration['mm_email_bounce_reply_to'];
  $mm_email_bounce_subject = $configuration['mm_email_bounce_subject'];
  $mm_email_bounce_text = $configuration['mm_email_bounce_text'];
  $file_types = $configuration['mm_email_allowed_files'];

  // log setting
  $always_notify = 0;
  
  //variable get? or faster way
  $admin_email = '';

  $pop3 = new POP3();

  if (!$pop3->connect($mailserver_uri, $mailserver_port)) {
    watchdog(MM_EMAIL_WATCHDOG_TYPE, $pop3->ERROR, WATCHDOG_ERROR);
    return;
  }

  $count = $pop3->login($mailserver_login, $mailserver_password);
  $date = date('Y-m-d H:i:s');

  $_count = ($count) ? $count : 'NO';
  $message = "$_count messages at $mailserver_login at $date";

  watchdog(MM_EMAIL_WATCHDOG_TYPE, $message);

  if (0 == $count) {
    if (1 == $always_notify) {
      watchdog(MM_EMAIL_WATCHDOG_TYPE, t('There doesn\'t seem to be any new mail.'));
    }
    return;
  }

  $logfile = '';
  for ($i = 1; $i <= $count; $i++) {
    $message = $pop3->get($i);
    
    $del_id = ($mm_email_delete_emails) ? $i : null;
    $success = _media_mover_email_process_email($file_data_array, $message, $logfile, $pop3, $del_id, $file_types);

    if ($success && $mm_email_confirm_send_emails) {
     // @ TODO make this use drupal's mail function drupal_mail
     mail($success, $mm_email_confirm_subject, $mm_email_confirm_text, "Reply-To: \nFrom: \n");
    }
  }

  $pop3->quit();

  return $file_data_array;
}

/**
 * this llops through the message, finds the files 
 * 
 */
function _media_mover_email_process_email(&$file_data_array,& $message, & $logfile, & $pop3, $del_id,$file_types) {

  $content = '';
  $content_type = '';
  $boundary = '';
  $bodysignal = 0;
  $phone_delim = '::';
  $content_types = array(); 
  
  //extract header info
  foreach ($message as $line) {
    if (preg_match('/Content-Type: /i', $line)) {
      $content_type = trim($line);
      $content_type = substr($content_type, 14, strlen($content_type) - 14);
      $content_type = explode(';', $content_type);
      $content_types[] = $content_type = $content_type[0];       
    }  
      
    if (($content_type == 'multipart/alternative' || $content_type == 'multipart/mixed')
       && (preg_match('/boundary="/', $line)) && ($boundary == '')) {
      $boundary = trim($line);
      $boundary = explode('"', $boundary);
      $boundary = $boundary[1];
    }
  
      if (preg_match('/Subject: /i', $line)) {
        $subject = _media_mover_email_process_subject($line, $phone_delim);
      } 
      elseif (preg_match('/From: /', $line) | preg_match('/Reply-To: /', $line)) {
        $from_email = '';
        $from = _media_mover_email_process_user($line,$from_email);
      } 
      elseif (preg_match('/Date: /i', $line)) { // of the form '20 Mar 2002 20:32:37'
        $sent = _media_mover_email_process_date($line);
      } 
      else {
        $bodysignal = (strlen($line) < 3) ? 1 : 0;
        $content .=   $line;
      } 
    
  }
  
  // general media mover message info
  $data = array();
  $node['title'] = $subject;
  $node['created'] = $sent;
  $user['mail'] = $from_email;
  $user['from'] = $from;
  //init
  $node['body'] = '';
  $node['id'] = md5($subject.$sent.$from_email.$from);
  
  $replace_success = _media_mover_email_content($file_data_array, $content, $boundary, $file_types, $sent, $node, $user);

  if (!empty ($del_id) && !$pop3->delete($del_id)) {
    $logfile .= 'Oops ' . $pop3->ERROR . "\r\n";
    $pop3->reset();
    watchdog(MM_EMAIL_WATCHDOG_TYPE, 'wp-mail error', WATCHDOG_ERROR);
    return false;
  } else if ($replace_success) {
    return $from_email;
  } else {
    return false;
  }
}


/**
 * function for processing the an emails Date line
 * */
function _media_mover_email_create_file(&$file_array,& $raw_content, $filename,$types) {
  // get file path from media mover
  $file_location = media_mover_api_dir_path() . MM_EMAIL_ATTACHMENTS_SUBDIRECTORY ;
  // build the file
  $the_file = file_create_filename($filename, $file_location);
  
  $fh = @ fopen($the_file, "wb");
  $raw_content = str_replace("\n", '', $raw_content);
  $raw_content = str_replace("\r", '', $raw_content);
  @ fwrite($fh, base64_decode($raw_content));
  @ fclose($fh);
  
  $file_array['filesize'] = filesize($the_file) | 0;
  
  // build the list of file types
  $file_types = explode(' ', strtolower($types));  
  
  $success = _media_mover_email_security($the_file, $file_types);
  if ($success) watchdog(MM_EMAIL_WATCHDOG_TYPE, 'Email attachment harvested: '. $the_file);
  
  // append the file to the file array
  $file_array['filename'] = $the_file;
  
  // set the harvested file path
  $file_array['filepath'] =  $the_file;
  // set the name of the harvest module
  $file_array['harvest_module'] = 'media_mover_email_harvest';
  // set the action id
  $file_array['harvest_action'] = 1;
  
  $file_array['harvest_file'] = $file_array['filepath'];

  return $success;
}

/**
 * traverse the data contained in the email looking for relevant parts.
 * */
function _media_mover_email_content(&$file_data_array, &$content, $boundary, $file_types, $date = null, $node = null, $user = null) {
  global $mm_email_content_count;
  if (empty($mm_email_content_count)) {
    $mm_email_content_count = 0;  
  }
  
  $body = '';
  //the array of info for this specific file
  $file_array = array();
  $file_array['node'] = $node;
  $file_array['user'] = $user; 
  $file_array['nid'] = null;
  //$file_array['created'] = microtime();
  //$file_array['changed'] = microtime();
  $file_array['node']['promote'] = 0;
  $file_array['node']['moderate'] = 0;
  $file_array['node']['sticky'] = 0;
  $file_array['node']['status'] = 0;
  
  //track the messages' keys for adding body later
  $mm_email_content_count_array = array();
  
  $final_success = false;
  
  //get parts 
  if ($boundary != ''){
    $temp_content = explode($boundary, $content);
  } 
  else{
    $temp_content = $content;
  }

  if (is_array($temp_content)) {
    foreach ($temp_content as $key => $segment) {
       //make a fresh copy
       $_file_array = $file_array;
       //parse and save body for later
       $body .= _media_mover_email_parse_segment($segment, $_file_array, $file_types, $final_success, $date);       
       if (isset($_file_array['filesize'])){
        $mm_email_content_count++;
        $mm_email_content_count_array[$mm_email_content_count] = $mm_email_content_count;
        $file_data_array[$mm_email_content_count] = $_file_array; 
       }
    }

    // now add the body
    if ($file_data_array) {
      foreach ($file_data_array as $key => $t_file_array) {
        if (isset( $mm_email_content_count_array[$key]) ) {
          $file_data_array[$key]['data']['body'] = $body;
        }
      }
    }
  } 
  else { // not a multipart email
    $_file_array = $file_array;
    _media_mover_email_parse_segment($temp_content, $_file_array, $file_types, $final_success, $date);
    $mm_email_content_count++;
    $file_data_array[$mm_email_content_count] = $_file_array; 
  }
  
  return $final_success;
}


/**
 * parses an email segment
 * */
function _media_mover_email_parse_segment(&$segment, &$_file_array, &$file_types, &$final_success, $date){
  
  $body = '';
  // if content time is image
  $pattern1 = '/Content-Type: image\//i';
  $pattern1a = '/Content-Type: video\//i';
  //if html
  $pattern2 = '/Content-Type: text\/html/i';
  $pattern3 = '/Content-Type: text\/plain/i';
  
  // filename if image
  $pattern4 = '/Content-Location: (.*)/i';
  $pattern5 = '/Content-Type: (\S*)(.*)/i';
      
  $raw_content = _media_mover_email_get_content_from_segment($segment);

  // should it be decoded?
  $do_decode = preg_match('/Content-Transfer-Encoding: base64/i', $segment);

  if (preg_match($pattern1, $segment) || preg_match($pattern1a, $segment)) {
   //['filemime'] = $mimetype; $pattern_get_filename = "/Content-Location: (.*)/i";
    $pattern_get_filename = "/Content-Disposition: (.*)/i";
 
    $new_filename = array ();
    
    // file name pattern 
    $pattern_get_filename = array(
       '/filename=(.*)/i', 
       '/name=(.*)/i'
     );
    
    foreach( $pattern_get_filename as $pattern) {
      preg_match($pattern, $segment, $new_filename);
      if ($new_filename) {continue; }
    }
        
    // debug if the filename can't be found
    if (empty($new_filename)){
    	 $success = false;
       $temail   = variable_get('MEDIA_MOVER_MODULE_DEBUG_EMAIL','') ;
       if (!$temail) {
       	  watchdog('MEDIA MOVER','The admin debugging email should be set at admin/settings/media_mover');
       }
    	 else {
    	 	mail($temail,'EMAIL MEDIA MOVER: Debugging: FILENAME NOT RECOGNIZED',$segment);
    	 }
    } 
    else {
      // strip quotes out
	    $filename = trim(str_replace('"','' , $new_filename[1]));
     
	    preg_match($pattern5, $segment, $mime_type);
	    $_file_array['filemime'] = trim(str_replace(';','',$mime_type[1]));
	    
	    $success = _media_mover_email_create_file($_file_array,$raw_content, $filename, $file_types);
	  }
	  
    //track that these files were successfully created
    $final_success = $success && $final_success;
  } 
  elseif (preg_match($pattern2, $segment)) {
    if ($do_decode)
      $raw_content = base64_decode($raw_content);
      $body = $raw_content;

    } 
    elseif (preg_match($pattern3, $segment)) {
      
      //not an image      
      if ($do_decode)
        $raw_content = base64_decode($raw_content);

      $body = $raw_content;
    } 
    else {
     
    }    
    return $body;
}
